import Component from '@glimmer/component';
import ShikiService from '../services/shiki';
import { Lang, Theme } from 'shiki';
import { SafeString } from '@ember/template';
import '../styles.css';
export type LineHighlightType = 'neutral' | 'add' | 'remove';
export interface LineHighlight {
    start: number;
    end?: number;
    type: LineHighlightType;
}
export interface CodeBlockSignature {
    Args: {
        code: string;
        language?: Lang | string;
        theme?: Theme | string;
        name?: string;
        showCopyButton?: boolean;
        showLineNumbers?: boolean;
        lineNumberStart?: number;
        lineHighlights?: LineHighlight[];
        onCodeHighlighted?: (code: string, language?: Lang | string, theme?: Theme | string) => void;
    };
    Element: HTMLDivElement;
    Blocks: {
        loading: [];
    };
}
export default class CodeBlock extends Component<CodeBlockSignature> {
    shiki: ShikiService;
    fastboot?: any;
    renderedCode?: SafeString;
    constructor(owner: unknown, args: CodeBlockSignature['Args']);
    get showLineNumbers(): boolean;
    get showCopyButton(): boolean;
    get codeLines(): string[];
    get lineNumberStartStyle(): SafeString;
    onCodeHighlighted: (rendered: string, code: string, language?: Lang | string, theme?: Theme | string) => void;
}
//# sourceMappingURL=code-block.d.ts.map