import Service from '@ember/service';
import type { BUNDLED_LANGUAGES, BUNDLED_THEMES, Highlighter, Lang, Theme } from 'shiki';
import { LineHighlight } from '../components/code-block';
export default class ShikiService extends Service {
    isInitialized: boolean;
    highlighter?: Highlighter;
    BUNDLED_LANGUAGES?: typeof BUNDLED_LANGUAGES;
    BUNDLED_THEMES?: typeof BUNDLED_THEMES;
    loadLanguageTask: import("ember-concurrency").TaskForAsyncTaskFunction<{
        enqueue: boolean;
    }, (language: Lang) => Promise<void>>;
    loadThemeTask: import("ember-concurrency").TaskForAsyncTaskFunction<{
        enqueue: boolean;
    }, (theme: Theme) => Promise<void>>;
    get cdnUrl(): any;
    initialize: import("ember-concurrency").TaskForAsyncTaskFunction<{
        enqueue: boolean;
    }, () => Promise<void>>;
    render: import("ember-concurrency").TaskForAsyncTaskFunction<{}, (code: string, language?: Lang | string, theme?: Theme | string, lineHighlights?: LineHighlight[]) => Promise<string>>;
    mapLineHighlightsToShikiOptions(lineHighlights: LineHighlight[]): {
        line: number;
        classes: string[];
    }[];
}
declare module '@ember/service' {
    interface Registry {
        shiki: ShikiService;
    }
}
//# sourceMappingURL=shiki.d.ts.map