import { _ as _applyDecoratedDescriptor, a as _initializerDefineProperty, b as _defineProperty } from '../_rollupPluginBabelHelpers-e795903d.js';
import { getOwner } from '@ember/application';
import { service } from '@ember/service';
import Component from '@glimmer/component';
import { tracked } from '@glimmer/tracking';
import { htmlSafe } from '@ember/template';
import '../styles.css';
import { precompileTemplate } from '@ember/template-compilation';
import { setComponentTemplate } from '@ember/component';

var TEMPLATE = precompileTemplate("<div class=\"shiki-code-block\" style={{this.lineNumberStartStyle}} ...attributes>\n  {{#if @name}}\n    <div class=\"shiki-code-block__name\">\n      {{@name}}\n    </div>\n  {{/if}}\n  <div\n    class=\"shiki-code-block__code\n      {{if this.showLineNumbers \'line-numbers\'}}\"\n  >\n    <div\n      {{shiki-render\n        code=@code\n        language=@language\n        theme=@theme\n        onCodeHighlighted=this.onCodeHighlighted\n        lineHighlights=@lineHighlights\n      }}\n    >\n      {{#if this.renderedCode}}\n        {{this.renderedCode}}\n      {{else if (has-block \"loading\")}}\n        {{yield to=\"loading\"}}\n      {{else}}\n        {{!-- This formatting seems ugly, and it is, but whitespace it shown literally in `pre` elements so it\'s important to get it right --}}\n        <pre class=\"shiki shiki--loading\" tabindex=\"0\"><code>{{#each this.codeLines as |line|}}<span class=\"line\">{{line}}</span>\n{{/each}}</code></pre>\n      {{/if}}\n    </div>\n    {{#if this.showCopyButton}}\n      <CopyButton @text={{@code}} />\n    {{/if}}\n  </div>\n</div>");

var _class, _descriptor, _descriptor2;
let CodeBlock = (_class = class CodeBlock extends Component {
  constructor(owner, args) {
    super(owner, args);

    // Attempt to inject fastboot service
    _initializerDefineProperty(this, "shiki", _descriptor, this);
    // eslint-disable-next-line @typescript-eslint/no-explicit-any
    _defineProperty(this, "fastboot", void 0);
    _initializerDefineProperty(this, "renderedCode", _descriptor2, this);
    _defineProperty(this, "onCodeHighlighted", (rendered, code, language, theme) => {
      this.renderedCode = htmlSafe(rendered);
      this.args.onCodeHighlighted?.(code, language, theme);
    });
    this.fastboot = getOwner(this)?.lookup('service:fastboot');
    if (this.fastboot && this.fastboot.isFastBoot) {
      const shikiRenderCompleted = new Promise(resolve => {
        const {
          code,
          language,
          theme,
          lineHighlights
        } = this.args;
        this.shiki.render.perform(code, language, theme, lineHighlights).then(rendered => {
          this.onCodeHighlighted(rendered, code, language, theme);
          resolve(true);
        });
      });
      this.fastboot.deferRendering(shikiRenderCompleted);
    }
  }
  get showLineNumbers() {
    if (this.args.showLineNumbers !== undefined) {
      return this.args.showLineNumbers;
    }

    // eslint-disable-next-line @typescript-eslint/no-explicit-any
    const config = getOwner(this)?.resolveRegistration('config:environment');
    const {
      showLineNumbers
    } = config['ember-shiki'] ?? {};
    return showLineNumbers ?? false;
  }
  get showCopyButton() {
    if (this.args.showCopyButton !== undefined) {
      return this.args.showCopyButton;
    }

    // eslint-disable-next-line @typescript-eslint/no-explicit-any
    const config = getOwner(this)?.resolveRegistration('config:environment');
    const {
      showCopyButton
    } = config['ember-shiki'] ?? {};
    return showCopyButton ?? true;
  }
  get codeLines() {
    return this.args.code.split('\n');
  }
  get lineNumberStartStyle() {
    if (!this.args.lineNumberStart) {
      return htmlSafe('');
    }
    return htmlSafe(`--ember-shiki-line-number-start: ${this.args.lineNumberStart}`);
  }
}, (_descriptor = _applyDecoratedDescriptor(_class.prototype, "shiki", [service], {
  configurable: true,
  enumerable: true,
  writable: true,
  initializer: null
}), _descriptor2 = _applyDecoratedDescriptor(_class.prototype, "renderedCode", [tracked], {
  configurable: true,
  enumerable: true,
  writable: true,
  initializer: null
})), _class);
setComponentTemplate(TEMPLATE, CodeBlock);

export { CodeBlock as default };
//# sourceMappingURL=code-block.js.map
